Package org.springframework.http.converter.xml

# Class SourceHttpMessageConverter<T extends Source>

java.lang.Object
org.springframework.http.converter.AbstractHttpMessageConverter<T>
org.springframework.http.converter.xml.SourceHttpMessageConverter<T>

Type Parameters:
  `T` - the converted object type

All Implemented Interfaces:
  `HttpMessageConverter<T>`

public class SourceHttpMessageConverter<T extends Source> extends AbstractHttpMessageConverter<T>
Implementation of `HttpMessageConverter` that can read and write `Source` objects.

Since:
  3.0
Author:
  Arjen Poutsma, Rossen Stoyanchev, Juergen Hoeller

## Field Summary

### Fields inherited from class org.springframework.http.converter.AbstractHttpMessageConverter

`logger`

## Constructor Summary

Constructors
Constructor
Description
`SourceHttpMessageConverter()`
Sets the `supportedMediaTypes` to `text/xml` and `application/xml`, and `application/*+xml`.

## Method Summary

Modifier and Type
Method
Description
`protected Long`
`getContentLength(T t, MediaType contentType)`
Returns the content length for the given type.
`boolean`
`isProcessExternalEntities()`
Return whether XML external entities are allowed.
`boolean`
`isSupportDtd()`
Return whether DTD parsing is supported.
`protected T`
`readInternal(Class<? extends T> clazz, HttpInputMessage inputMessage)`
Abstract template method that reads the actual object.
`void`
`setProcessExternalEntities(boolean processExternalEntities)`
Indicate whether external XML entities are processed when converting to a Source.
`void`
`setSupportDtd(boolean supportDtd)`
Indicate whether DTD parsing should be supported.
`boolean`
`supports(Class<?> clazz)`
Indicates whether the given class is supported by this converter.
`protected boolean`
`supportsRepeatableWrites(T t)`
Indicates whether this message converter can write the given object multiple times.
`protected void`
`writeInternal(T t, HttpOutputMessage outputMessage)`
Abstract template method that writes the actual body.

### Methods inherited from class org.springframework.http.converter.AbstractHttpMessageConverter

`addDefaultHeaders, canRead, canRead, canWrite, canWrite, getDefaultCharset, getDefaultContentType, getSupportedMediaTypes, read, setDefaultCharset, setSupportedMediaTypes, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.http.converter.HttpMessageConverter

`getSupportedMediaTypes`

## Constructor Details

### SourceHttpMessageConverter

public SourceHttpMessageConverter()
Sets the `supportedMediaTypes` to `text/xml` and `application/xml`, and `application/*+xml`.

## Method Details

### setSupportDtd

public void setSupportDtd(boolean supportDtd)
Indicate whether DTD parsing should be supported.

Default is `false` meaning that DTD is disabled.

### isSupportDtd

public boolean isSupportDtd()
Return whether DTD parsing is supported.

### setProcessExternalEntities

public void setProcessExternalEntities(boolean processExternalEntities)
Indicate whether external XML entities are processed when converting to a Source.

Default is `false`, meaning that external entities are not resolved.

Note: setting this option to `true` also automatically sets `setSupportDtd(boolean)` to `true`.

### isProcessExternalEntities

public boolean isProcessExternalEntities()
Return whether XML external entities are allowed.

### supports

public boolean supports(Class<?> clazz)
Description copied from class: `AbstractHttpMessageConverter`
Indicates whether the given class is supported by this converter.

Specified by:
  `supports` in class `AbstractHttpMessageConverter<T extends Source>`
Parameters:
  `clazz` - the class to test for support
Returns:
  `true` if supported; `false` otherwise

### readInternal

protected T readInternal(Class<? extends T> clazz, HttpInputMessage inputMessage) throws IOException, HttpMessageNotReadableException
Description copied from class: `AbstractHttpMessageConverter`
Abstract template method that reads the actual object. Invoked from `AbstractHttpMessageConverter.read(java.lang.Class<? extends T>, org.springframework.http.HttpInputMessage)`.

Specified by:
  `readInternal` in class `AbstractHttpMessageConverter<T extends Source>`
Parameters:
  `clazz` - the type of object to return
  `inputMessage` - the HTTP input message to read from
Returns:
  the converted object
Throws:
  `IOException` - in case of I/O errors
  `HttpMessageNotReadableException` - in case of conversion errors

### getContentLength

@Nullable protected Long getContentLength(T t, @Nullable MediaType contentType)
Description copied from class: `AbstractHttpMessageConverter`
Returns the content length for the given type.

By default, this returns `null`, meaning that the content length is unknown. Can be overridden in subclasses.

Overrides:
  `getContentLength` in class `AbstractHttpMessageConverter<T extends Source>`
Parameters:
  `t` - the type to return the content length for
Returns:
  the content length, or `null` if not known

### writeInternal

protected void writeInternal(T t, HttpOutputMessage outputMessage) throws IOException, HttpMessageNotWritableException
Description copied from class: `AbstractHttpMessageConverter`
Abstract template method that writes the actual body. Invoked from `AbstractHttpMessageConverter.write(T, org.springframework.http.MediaType, org.springframework.http.HttpOutputMessage)`.

Specified by:
  `writeInternal` in class `AbstractHttpMessageConverter<T extends Source>`
Parameters:
  `t` - the object to write to the output message
  `outputMessage` - the HTTP output message to write to
Throws:
  `IOException` - in case of I/O errors
  `HttpMessageNotWritableException` - in case of conversion errors

### supportsRepeatableWrites

protected boolean supportsRepeatableWrites(T t)
Description copied from class: `AbstractHttpMessageConverter`
Indicates whether this message converter can write the given object multiple times.

The default implementation returns `false`.

Overrides:
  `supportsRepeatableWrites` in class `AbstractHttpMessageConverter<T extends Source>`
Parameters:
  `t` - the object t
Returns:
  `true` if `t` can be written repeatedly; `false` otherwise